#!/bin/bash

PUID=${PUID:-911}
PGID=${PGID:-911}

groupmod -o -g "$PGID" abc
usermod -o -u "$PUID" abc

echo '
-------------------------------------
GID/UID
-------------------------------------'
echo "
User uid:    $(id -u abc)
User gid:    $(id -g abc)
-------------------------------------
"

chown abc:abc /app
chown abc:abc /config

echo "Booted face fusion"

cd /facefusion && source ./bin/activate && \
 GRADIO_SERVER_NAME=0.0.0.0 python3 run.py \
 --log-level debug \
 --execution-thread-count 8 &

echo "Booting app"
cd /app && ./main