package gomatrixbot

import (
	"context"

	gowiki "github.com/trietmn/go-wiki"
	"maunium.net/go/mautrix/id"
)

func (mtrx *MtrxClient) searchWiki(ctx context.Context, roomID id.RoomID, search string) {
	// Search for the Wikipedia page title
	search_result, _, err := gowiki.Search(search, 3, false)
	if err != nil {
		mtrx.sendMessage(ctx, roomID, "Error searching: "+err.Error())
		return
	}

	if len(search_result) == 0 {
		mtrx.sendMessage(ctx, roomID, "No results found")
		return
	}

	// Get the page
	page, err := gowiki.GetPage(search_result[0], -1, false, true)
	if err != nil {
		mtrx.sendMessage(ctx, roomID, "Error fetching page: "+err.Error())
		return
	}

	// Get the content of the page
	content, err := page.GetSummary()
	if err != nil {
		mtrx.sendMessage(ctx, roomID, "Error getting summary: "+err.Error())
		return
	}

	mtrx.sendMessage(ctx, roomID, search_result[0]+"\n"+content)
}
