package gomatrixbot

import (
	"context"
	"fmt"
	"time"

	"github.com/lrstanley/go-ytdlp"
	"maunium.net/go/mautrix/id"
	"mvdan.cc/xurls/v2"
)

func (mtrx *MtrxClient) pullVideo(ctx context.Context, room id.RoomID, url string) {
	rxStrict := xurls.Strict()
	urls := rxStrict.FindAllString(url, -1)
	if urls != nil && len(urls) > 0 {
		for _, v := range urls {
			err := mtrx.getAndUploadVideo(v, room)
			if err != nil {
				mtrx.sendMessage(ctx, room, "Failed to download video: "+err.Error())
				continue
			}
		}
	}
}

func (mtrx *MtrxClient) getAndUploadVideo(url string, roomID id.RoomID) error {
	filename := fmt.Sprintf("%d", time.Now().UnixMilli())

	dl := ytdlp.New().
		FormatSort("res,ext:mp4:m4a").
		// RecodeVideo("mp4").
		Output("/tmp/" + filename + ".mp4")

	_, err := dl.Run(context.TODO(), url)
	if err != nil {
		return err
	}

	// Upload
	mtrx.uploadAndPostVideo(context.TODO(), roomID, "/tmp/"+filename+".mp4")

	// Nice
	return nil
}
